HaXml-1.25.4: Utilities for manipulating XML documents

Safe Haskell | Safe
Language | Haskell98

Text.XML.HaXml.Xtract.Lex

Description

This is another hand-written lexer, this time for the Xtract command-language. The entry point is lexXtract. You don't normally need to use this module directly - the lexer is called automatically by the parser. (We only expose this interface for debugging purposes.)

The Xtract command language is very like the XPath specification.

Synopsis

- lexXtract :: (String -> String) -> String -> [Token]
- data Posn = Pn Int
- data TokenT
  - = Symbol String
  - | TokString String
  - | TokNum Integer
- type Token = Either String (Posn, TokenT)

# Documentation

lexXtract :: (String -> String) -> String -> [Token] #

First argument is a transformer for pattern strings, e.g. map toLower, but only applying to parts of the pattern not in quotation marks. (Needed to canonicalise HTML where tags are case-insensitive, but attribute values are case sensitive.)

data Posn #

Constructors

Pn Int |

Instances

Eq Posn # |
Methods (==) :: Posn -> Posn -> Bool # (/=) :: Posn -> Posn -> Bool #
Show Posn # |
Methods showsPrec :: Int -> Posn -> ShowS # show :: Posn -> String # showList :: [Posn] -> ShowS #

data TokenT #

Constructors

Symbol String |
TokString String |
TokNum Integer |

Instances

Eq TokenT # |
Methods (==) :: TokenT -> TokenT -> Bool # (/=) :: TokenT -> TokenT -> Bool #
Show TokenT # |
Methods showsPrec :: Int -> TokenT -> ShowS # show :: TokenT -> String # showList :: [TokenT] -> ShowS #

type Token = Either String (Posn, TokenT) #